#include "stdafx.h"
#include "NeMessenger.h"
#include "ChatUserList.h"
#include "ChatSplitterWnd.h"


IMPLEMENT_DYNAMIC(CChatUserList, CListCtrl)

CChatUserList::CChatUserList()
{
	m_bHandCursor = FALSE;
	m_uItemHeight = 0;
	m_bMouseTrack = true;
	m_nPrevIndex = -1;
	m_bEnableHove = false;
    m_pilIPTPresence = NULL;
}

CChatUserList::~CChatUserList()
{
	// ޸ ȯ  ClearUserListItem() θâ ȣѴ.

    m_pilIPTPresence = NULL;
}

BEGIN_MESSAGE_MAP(CChatUserList, CListCtrl)
	ON_WM_MEASUREITEM_REFLECT()
	ON_NOTIFY_REFLECT(NM_CUSTOMDRAW, OnCustomDraw)
	ON_MESSAGE(UM_SPLITTER_MOVE, OnUmSplitterMove)
	ON_NOTIFY_REFLECT(LVN_HOTTRACK, &CChatUserList::OnLvnHotTrack)
	ON_WM_SETCURSOR()
	ON_WM_TIMER()
	ON_WM_SIZE()
	ON_WM_KILLFOCUS()
	ON_WM_NCCALCSIZE()
	ON_WM_MOUSELEAVE()
	ON_WM_MOUSEMOVE()
	ON_WM_MOUSEHOVER()
END_MESSAGE_MAP()

void CChatUserList::ClearUserListItem()
{
	CSingleLock lock(&m_csLock, TRUE);

	_chat_user_info* pUserInfo = NULL;

	int nCnt = GetItemCount();
	for (int i = 0; i < nCnt; i++)
	{
		pUserInfo = (_chat_user_info*)GetItemData(i);
		if (!pUserInfo)
			continue;

		delete pUserInfo;
		pUserInfo = NULL;
	}

	DeleteAllItems();
}

//void CChatUserList::DeleteChatItem(CString strUserName, CString strUserNickName)
//{
//	_chat_user_info* pUserInfo = NULL;
//
//	int nCnt = GetItemCount();
//	for (int i = 0; i < nCnt; i++)
//	{
//		pUserInfo = (_chat_user_info*)GetItemData(i);
//		if (!pUserInfo)
//			continue;
//
//		if (pUserInfo->strUserName.Compare(strUserName) == 0 && pUserInfo->strUserNickName.Compare(strUserNickName) == 0)
//		{
//			delete pUserInfo;
//			DeleteItem(i);
//
//			break;
//		}
//	}
//}

LRESULT CChatUserList::OnUmSplitterMove(WPARAM wParam, LPARAM lParam)
{
	int nMove = (int)lParam;
	if (nMove == 0)
		return 0;

    CRect rtWnd(0, 0, 0, 0);
	GetWindowRect(&rtWnd);

	rtWnd.InflateRect(0, 0, 0, nMove);
	if (rtWnd.Height() <= DEF_CHAT_USERLIST_ITEM_HEIGHT)
		return 0;

	//must first ensure then move
	EnsureVisible(0, FALSE);

	CWnd* pWndParent = GetParent();
	if (!pWndParent)
		return 0;
	pWndParent->ScreenToClient(&rtWnd);

	MoveWindow(&rtWnd);

	return 1;
}
void CChatUserList::MeasureItem(LPMEASUREITEMSTRUCT lpMeasureItemStruct)
{
	if(m_uItemHeight > 0)
	{
		lpMeasureItemStruct->itemHeight = m_uItemHeight; 
	}
}

void CChatUserList::DrawItem(LPDRAWITEMSTRUCT lpDrawItemStruct)
{
	CDC dc;
	dc.Attach(lpDrawItemStruct->hDC);

	int nColumnCount = 0;

	CHeaderCtrl* pHeaderCtrl = GetHeaderCtrl();
	if (pHeaderCtrl)
		nColumnCount = pHeaderCtrl->GetItemCount();

	for(int i = 0; i < nColumnCount; i++)
	{
		DrawSubItem(lpDrawItemStruct->itemID, i, &dc);
	}

	dc.Detach();
}
void CChatUserList::OnCustomDraw(NMHDR* pNMHDR, LRESULT* pResult)
{
	NMLVCUSTOMDRAW* pLVCD = reinterpret_cast<NMLVCUSTOMDRAW*>(pNMHDR);

	int nItem = static_cast<int>(pLVCD->nmcd.dwItemSpec);
	int nSubItem = pLVCD->iSubItem;

	*pResult = CDRF_DODEFAULT;

	if (pLVCD->nmcd.dwDrawStage == CDDS_PREPAINT)
	{
		*pResult = CDRF_NOTIFYITEMDRAW;
	}
	else if (pLVCD->nmcd.dwDrawStage == CDDS_ITEMPREPAINT)
	{
		*pResult = CDRF_NOTIFYSUBITEMDRAW;
	}
	else if (pLVCD->nmcd.dwDrawStage == (CDDS_ITEMPREPAINT | CDDS_SUBITEM))
	{
		*pResult = CDRF_SKIPDEFAULT;

		CDC* pDC = CDC::FromHandle(pLVCD->nmcd.hdc);
		if (pDC != NULL)
			DrawSubItem(nItem, nSubItem, pDC);
	}
}

void CChatUserList::DrawSubItem(int nItem, int nSubItem, CDC *pDC)
{
	CRect rect(0, 0, 0, 0);
	//GetSubItemRect(nItem, nSubItem, LVIR_BOUNDS, rect);
	GetSubItemRect(nItem, nSubItem, LVIR_LABEL, rect);

	/* LVIR_BOUNDS ϸ Ư 쿡 Ʈ  ̰  ׷ ʴ´.
	 * Ƹ SubItem 0  ش Row ü  ͼ  ĥֱ  ׷  .
	 *   ذϱ  LVIR_LABEL  ϸ ̴  , SubItem 0  left  right  ũ ´.
	 * ׷ SubItem 0ΰ left   ִ  óϿ.
	 */
	if (nSubItem == 0)
		rect.left = 0;

	COLORREF crText;
	COLORREF crBkgnd;

	GetDrawColors(nItem, nSubItem, crText, crBkgnd);
	pDC->FillSolidRect(&rect, crBkgnd);

	_chat_user_info UserInfo;
	{
		CSingleLock lock(&m_csLock, TRUE);
		_chat_user_info* pUserInfo = (_chat_user_info*)GetItemData(nItem);
		if (!pUserInfo)
			return;

		UserInfo = *pUserInfo;
	}

	//  Ʈ ÷ 3(, ̸  Ÿ , IPT)̴.
	if (nSubItem == UL_COLUMN_STATUS)	// ޽  
	{
		LVITEM rItem;

		//  ε
		ZeroMemory(&rItem, sizeof(LVITEM));
		rItem.mask  = LVIF_IMAGE | LVIF_STATE;
		rItem.iItem = nItem;
		rItem.stateMask = LVIS_SELECTED;
		GetItem(&rItem);

		CRect rcImage(0, 0, 0, 0);
		GetSubItemRect(nItem, nSubItem, LVIR_ICON, rcImage);

		// ׳ ׸    Ǿ, η    ̹   ش.
		IMAGEINFO imgInfo;
		ZeroMemory(&imgInfo, sizeof(IMAGEINFO));
		GetImageList(LVSIL_SMALL)->GetImageInfo(rItem.iImage, &imgInfo);
		CPoint ptImg(rcImage.TopLeft());
		ptImg.Offset(8, (rcImage.Height() - (imgInfo.rcImage.bottom - imgInfo.rcImage.top)) / 2);
		GetImageList(LVSIL_SMALL)->Draw(pDC, rItem.iImage, ptImg, ILD_TRANSPARENT);
	}
	else if (nSubItem == UL_COLUMN_NAME)	// ̸ ÷ '̸ [ȣ]'  Ѵ.
	{
		UINT nFormat = DT_VCENTER | DT_SINGLELINE | DT_END_ELLIPSIS | DT_NOPREFIX | DT_LEFT;
		rect.left += 4;

		CFont *pOldFont = pDC->SelectObject(&g_ftDefault9PTB);
		
		pDC->SetBkMode(TRANSPARENT);
		pDC->SetTextColor(crText);
		pDC->SetBkColor(crBkgnd);
		pDC->DrawText(UserInfo.strUserName, &rect, nFormat);

		CString strUserInfo;

		if (!UserInfo.strJobPos.IsEmpty() && !UserInfo.strJobDuty.IsEmpty())
		{
			strUserInfo.Format(_T("[%s/%s] %s"), UserInfo.strJobPos, UserInfo.strJobDuty, UserInfo.strUserDepart);
		}
		else if (!UserInfo.strJobPos.IsEmpty() && UserInfo.strJobDuty.IsEmpty())
		{
			strUserInfo.Format(_T("[%s] %s"), UserInfo.strJobPos, UserInfo.strUserDepart);
		}
		else if (UserInfo.strJobPos.IsEmpty() && !UserInfo.strJobDuty.IsEmpty())
		{
			strUserInfo.Format(_T("[%s] %s"), UserInfo.strJobDuty, UserInfo.strUserDepart);
		}
		else
		{
			strUserInfo.Format(_T("%s"), UserInfo.strUserDepart);
		}
		
		CSize szName = pDC->GetTextExtent(UserInfo.strUserName);
		rect.left += szName.cx + 6;

		pDC->SelectObject(&g_ftDefault8PT);
		pDC->DrawText(strUserInfo, &rect, nFormat);

		pDC->SelectObject(pOldFont);
	}
	else if (nSubItem == UL_COLUMN_IPT)		// IPT ÷
	{
		if (GET_APP()->IsAvailableIPT() && m_pilIPTPresence)	// ImageList   츸 
		{
			int nPresence = UserInfo.eIPTStatus;
			CRect rcImage(0, 0, 0, 0);
			GetSubItemRect(nItem, nSubItem, LVIR_ICON, rcImage);

			// ׳ ׸    Ǿ, η    ̹   ش.
			IMAGEINFO imgInfo;
			ZeroMemory(&imgInfo, sizeof(IMAGEINFO));
			m_pilIPTPresence->GetImageInfo(nPresence, &imgInfo);
			CPoint ptImg(rcImage.TopLeft());
			ptImg.Offset(5, (rcImage.Height() - (imgInfo.rcImage.bottom - imgInfo.rcImage.top)) / 2);
			m_pilIPTPresence->Draw(pDC, nPresence, ptImg, ILD_TRANSPARENT);
		}
	}
	else
	{
		CString strText = GetItemText(nItem, nSubItem);

		if (!strText.IsEmpty())
		{
			CFont *pOldFont = pDC->SelectObject(&g_ftDefault8PT);

			// get text justification
			HDITEM hditem;
			hditem.mask = HDI_FORMAT;
			GetHeaderCtrl()->GetItem(nSubItem, &hditem);

			int nFmt = hditem.fmt & HDF_JUSTIFYMASK;
			UINT nFormat = DT_VCENTER | DT_SINGLELINE | DT_END_ELLIPSIS | DT_NOPREFIX;

			if (nFmt == HDF_CENTER)
			{
				nFormat |= DT_CENTER;
			}
			else if (nFmt == HDF_LEFT)
			{
				nFormat |= DT_LEFT;
				rect.left += 4;
			}
			else
			{
				nFormat |= DT_RIGHT;
			}

			pDC->SetBkMode(TRANSPARENT);
			pDC->SetTextColor(crText);			
			pDC->SetBkColor(crBkgnd);
			pDC->DrawText(strText, &rect, nFormat);
			pDC->SelectObject(pOldFont);
		}
	}
}

void CChatUserList::GetDrawColors(int nItem, int nSubItem, COLORREF& colorText, COLORREF& colorBkgnd)
{
	DWORD dwStyle    = GetStyle();
	DWORD dwExStyle  = GetExtendedStyle();
	UINT uState = GetItemState(nItem, LVIS_FOCUSED | LVIS_SELECTED);
	//Trace(_T("---CChatUserList::GetDrawColors(%d, %d)\n"), nItem, uState);

	COLORREF crText  = CU_COLOR_NORMAL_TEXT;
	COLORREF crBkgnd = CU_COLOR_NORMAL_BK;

	if (uState & LVIS_SELECTED)
	{
		crText  = CU_COLOR_SELECTED_TEXT;
		crBkgnd = CU_COLOR_SELECTED_BK;
	}
	else if (nItem == m_hoverItem.iItem)
	{
		crBkgnd = CU_COLOR_OVER_BK;
	}

	colorText = crText;
	colorBkgnd = crBkgnd;
}

int CChatUserList::CellRectFromPoint(CPoint & point, RECT * cellrect, int * col)    const
{
	int colnum;
	// Ʈ䰡 LVS_REPORT 忡ִ Ȯ
	if( (GetWindowLong(m_hWnd, GWL_STYLE) & LVS_TYPEMASK) != LVS_REPORT ) 
		return -1;

	//  ȭ鿡 ̴ó  Row  ˾Ƴ
	int row = GetTopIndex();
	int bottom = row + GetCountPerPage();
	if( bottom > GetItemCount() )   bottom = GetItemCount();

	// ÷ ˾Ƴ
	CHeaderCtrl* pHeader = (CHeaderCtrl*)GetDlgItem(0);
	int nColumnCount = pHeader->GetItemCount();

	// 纸̴ Row 鰣  
	for( ;row <= bottom; row++)               
	{
		//   簢 ,  ԵǴ üũ        
		CRect rect(0, 0, 0, 0);
		GetItemRect( row, &rect, LVIR_BOUNDS );
		if( rect.PtInRect(point) )              
		{
			// ÷ã
			for( colnum = 0; colnum < nColumnCount; colnum++ ) 
			{
				int colwidth = GetColumnWidth(colnum);                
				if( point.x >= rect.left && point.x <= (rect.left + colwidth) ) 
				{
                    RECT rectClient= { 0 };
					GetClientRect( &rectClient );
					if( col ) *col = colnum;
					rect.right = rect.left + colwidth;

					//   Ŭ̾Ʈ   ʵ Ȯ
					if( rect.right > rectClient.right )             
						rect.right = rectClient.right;
					*cellrect = rect;

					return row;
				}
				rect.left += colwidth;
			}
		}
	}

	return -1;
}

void CChatUserList::SetRowHeight(int nRowHeight)
{
	//CFont font;
	//LOGFONT logfont;

	//CDC *pDC = GetDC();
	//if( !pDC ) return;

	//int nRevision=7;

	//logfont.lfHeight = -MulDiv(nRowHeight-nRevision, GetDeviceCaps(pDC->m_hDC, LOGPIXELSY), 72);
	//ReleaseDC( pDC );

	//logfont.lfEscapement	= 0;
	//logfont.lfOrientation	= 0;
	//logfont.lfWeight		= FW_NORMAL;
	//logfont.lfItalic		= FALSE;
	//logfont.lfUnderline		= FALSE;
	//logfont.lfStrikeOut		= FALSE;
	//logfont.lfCharSet		= ANSI_CHARSET;
	//logfont.lfOutPrecision	= OUT_DEFAULT_PRECIS;
	//logfont.lfClipPrecision	= CLIP_DEFAULT_PRECIS;
	//logfont.lfQuality		= PROOF_QUALITY;
	//logfont.lfPitchAndFamily= DEFAULT_PITCH;
	//_tcscpy_s(logfont.lfFaceName, _T("System"));
	//font.CreateFontIndirect(&logfont);

	//SetFont(&font);

	//font.DeleteObject();

	m_uItemHeight = nRowHeight;
    WINDOWPOS wp = {0};
	CRect rcWin(0, 0, 0, 0);
	GetWindowRect(&rcWin);
	wp.hwnd = m_hWnd;
	wp.cx = rcWin.Width();
	wp.cy = rcWin.Height();
	wp.flags = SWP_NOACTIVATE | SWP_NOMOVE | SWP_NOOWNERZORDER | SWP_NOZORDER;
	SendMessage(WM_WINDOWPOSCHANGED, 0, (LPARAM)&wp);
}

BOOL CChatUserList::SetItemImage(int nItem, int nSubItem, int nImage)
{
	if ((nItem < 0) || nItem >= GetItemCount())
		return FALSE;

	if ((nSubItem < 0) || nSubItem >= GetHeaderCtrl()->GetItemCount())
		return FALSE;

	LVITEM lvItem;
	lvItem.mask = LVIF_IMAGE;
	lvItem.iItem = nItem;
	lvItem.iSubItem = nSubItem;
	lvItem.iImage = nImage;

	return SetItem(&lvItem);
}

void CChatUserList::SetIPTPresenceImageList(CImageList* pilIPTPresence)
{
	m_pilIPTPresence = pilIPTPresence;
}

void CChatUserList::OnLvnHotTrack(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMLISTVIEW pNMLV = reinterpret_cast<LPNMLISTVIEW>(pNMHDR);
	//Trace(_T("OnLvnHotTrack() %d, %d (%d,%d)\n"), pNMLV->iItem, pNMLV->iSubItem, pNMLV->ptAction.x, pNMLV->ptAction.y);

	int row = 0, col = 0;
	CRect cellrt(0, 0, 0, 0);
	CPoint pt = pNMLV->ptAction;
	row = CellRectFromPoint(pt,&cellrt,&col);

	if (m_hoverItem.iItem != row /*pNMLV->iItem*/ || m_hoverItem.iSubItem != col/*pNMLV->iSubItem*/)
	{
		//CRect rtMouseLeaved;
		//CRect rtHover;
		//GetSubItemRect(m_hoverItem.iItem, m_hoverItem.iSubItem, LVIR_BOUNDS, rtMouseLeaved);
		//GetSubItemRect(pNMLV->iItem, pNMLV->iSubItem, LVIR_BOUNDS, rtHover);

		m_hoverItem.iItem = row/*pNMLV->iItem*/;
		m_hoverItem.iSubItem = col/*pNMLV->iSubItem*/;

		if (GET_CONFIG()->EnableFunction(_T("UI_03")) == TRUE)
		{
			if (m_hoverItem.iItem == -1)
				m_bHandCursor = FALSE;
			else
			{
				// Mouse over 
				m_bHandCursor = TRUE;
				SetTimer(TIMER_CHAT_USER_LIST_HOVER, 100, NULL);
			}
		}

		// Hover  ۵ ٽ ׸  ü Redraw Ѵ.
		RedrawWindow(NULL, NULL, RDW_INVALIDATE | RDW_UPDATENOW | RDW_ERASE);
	}

	*pResult = 0;
}

BOOL CChatUserList::OnSetCursor(CWnd* pWnd, UINT nHitTest, UINT message)
{
	if (m_bHandCursor)
	{
		SetCursor(AfxGetApp()->LoadStandardCursor(IDC_HAND));
		return TRUE;
	}

	return CListCtrl::OnSetCursor(pWnd, nHitTest, message);
}

void CChatUserList::UnSelectAll()
{
	// Select all of the items that are completely visible.
	int nLast = GetItemCount();

	for (int i = 0; i < nLast; i++)
	{
		//if (GetItemState(i, LVIS_SELECTED) == LVIS_SELECTED)
		{
			SetItemState(i, 0, LVIS_SELECTED);
			SetItemState(i, 0, LVIS_FOCUSED); //Ŀ 
		} 
	} 
}

void CChatUserList::OnTimer(UINT_PTR nIDEvent)
{
	if (nIDEvent == TIMER_CHAT_USER_LIST_HOVER)
	{
		CPoint p(GetMessagePos());
		ScreenToClient(&p);

        CRect rect(0, 0, 0, 0);
		GetClientRect(rect);

		if (!rect.PtInRect(p))
		{
			KillTimer(TIMER_CHAT_USER_LIST_HOVER);
			
			m_bHandCursor = FALSE;
			m_hoverItem.iItem = -1;
			m_hoverItem.iSubItem = 0;

			RedrawWindow(NULL, NULL, RDW_INVALIDATE | RDW_UPDATENOW | RDW_ERASE);
		}
	}
}

void CChatUserList::OnSize(UINT nType, int cx, int cy)
{
	CListCtrl::OnSize(nType, cx, cy);
	//Trace(_T("CChatUserList::OnSize(%d,%d)\n"), cx, cy);

	CRect rtClient(0, 0, 0, 0);
	GetClientRect(rtClient);

	int nColWidth = rtClient.Width() - GetColumnWidth(UL_COLUMN_STATUS) - GetColumnWidth(UL_COLUMN_IPT);

/*
	SCROLLBARINFO ScrollBarInfo;
	::ZeroMemory(&ScrollBarInfo,sizeof(ScrollBarInfo));
	ScrollBarInfo.cbSize = sizeof(ScrollBarInfo);

	// ũѹٰ  ׸ŭ ʺ ش.
	if (GetScrollBarInfo(OBJID_VSCROLL, &ScrollBarInfo))
	{
		if (!(ScrollBarInfo.rgstate[0] & STATE_SYSTEM_INVISIBLE))
		{
			nColWidth -= GetSystemMetrics(SM_CXVSCROLL);
		}
	}
*/

	SetColumnWidth(UL_COLUMN_NAME, nColWidth);
}

void CChatUserList::OnKillFocus(CWnd* pNewWnd)
{
	CListCtrl::OnKillFocus(pNewWnd);

	UnSelectAll();
}

void CChatUserList::OnNcCalcSize(BOOL bCalcValidRects, NCCALCSIZE_PARAMS* lpncsp)
{
	//   ϶ HScrollbar Ǵ  ´.
	ModifyStyle(WS_HSCROLL, 0);

	CListCtrl::OnNcCalcSize(bCalcValidRects, lpncsp);
}

void CChatUserList::OnMouseMove(UINT nFlags, CPoint point)
{
	CRect rect(0, 0, 0, 0);
	GetClientRect(&rect);
	CPoint pt(0, 0);
	GetCursorPos(&pt);
	ScreenToClient(&pt);
	UINT uFlags = 0;
	int nIndex = HitTest(pt, &uFlags);

	if (m_bEnableHove)
	{
		if (m_bMouseTrack)    
		{
			TRACKMOUSEEVENT csTME;
			csTME.cbSize = sizeof(csTME);
			csTME.dwFlags = TME_LEAVE|TME_HOVER;
			csTME.hwndTrack = m_hWnd;
			csTME.dwHoverTime = DEFAULT_TRACE_HOVE_TIME; 
			::_TrackMouseEvent(&csTME);
			m_bMouseTrack=false;  
		}

		if (-1 == nIndex || m_nPrevIndex != nIndex)
		{
			m_nPrevIndex = nIndex;
			::PostMessage(GetParent()->m_hWnd,UM_NOTIFY_STATUS_POPUP,0,(LPARAM)1);
		}
	}

	CListCtrl::OnMouseMove(nFlags, point);
}

void CChatUserList::OnMouseHover(UINT nFlags, CPoint point)
{
	if (m_bEnableHove)
	{
		int nIndex = HitTest(point, &nFlags);
		if (nIndex < 0)
		{
			return;
		}

        CRect rcWorkStatusBox(0, 0, 0, 0);
		GetSubItemRect(nIndex, 0, LVIR_BOUNDS, rcWorkStatusBox);//default
		rcWorkStatusBox.left = 5;
		rcWorkStatusBox.right = rcWorkStatusBox.left + 30;
		if (rcWorkStatusBox.PtInRect(point))
		{
			m_nPrevIndex = nIndex;
			::PostMessage(GetParent()->m_hWnd,UM_NOTIFY_STATUS_POPUP,(WPARAM)nIndex,(LPARAM)0);
		}else
		{
			::PostMessage(GetParent()->m_hWnd,UM_NOTIFY_STATUS_POPUP,(WPARAM)nIndex,(LPARAM)1);
		}

		m_bMouseTrack = true;
	}

	CListCtrl::OnMouseHover(nFlags,point);
}

void CChatUserList::OnMouseLeave()
{
	if (m_bEnableHove)
	{
		m_bMouseTrack = true;
		::PostMessage(GetParent()->m_hWnd,UM_NOTIFY_STATUS_POPUP,0,(LPARAM)1);
		m_nPrevIndex = -1;
	}

	CListCtrl::OnMouseLeave();
}

void CChatUserList::SetEnableHoveFlag(bool flag)
{
	m_bEnableHove = flag;
}


